// -*- C++ -*-
/*!
 * @file  AllControl_Test.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "AllControl_Test.h"

// Module specification
// <rtc-template block="module_spec">
static const char* allcontrol_test_spec[] =
  {
    "implementation_id", "AllControl_Test",
    "type_name",         "AllControl_Test",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "VenderName",
    "category",          "Category",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
AllControl_Test::AllControl_Test(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_trigerOut("triger", m_triger)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
AllControl_Test::~AllControl_Test()
{
}



RTC::ReturnCode_t AllControl_Test::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  
  // Set OutPort buffer
  addOutPort("triger", m_trigerOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t AllControl_Test::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AllControl_Test::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AllControl_Test::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AllControl_Test::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AllControl_Test::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t AllControl_Test::onExecute(RTC::UniqueId ec_id)
{
	std::cout << "triger: ";
	std::cin >> m_triger.data;
	std::cout << std::endl;
	m_trigerOut.write();
	m_triger.data = 0;
  return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t AllControl_Test::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AllControl_Test::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AllControl_Test::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AllControl_Test::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t AllControl_Test::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void AllControl_TestInit(RTC::Manager* manager)
  {
    coil::Properties profile(allcontrol_test_spec);
    manager->registerFactory(profile,
                             RTC::Create<AllControl_Test>,
                             RTC::Delete<AllControl_Test>);
  }
  
};


