// -*- C++ -*-
/*!
 * @file  all_controller_test.cpp
 * @brief ModuleDescription
 * @date $Date$
 *
 * $Id$
 */

#include "all_controller_test.h"

int i = 0;

// Module specification
// <rtc-template block="module_spec">
static const char* all_controller_test_spec[] =
  {
    "implementation_id", "all_controller_test",
    "type_name",         "all_controller_test",
    "description",       "ModuleDescription",
    "version",           "1.0.0",
    "vendor",            "Test",
    "category",          "controlle",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
all_controller_test::all_controller_test(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_trigerIn("triger", m_triger),
    m_armOut("arm", m_arm),
    m_handOut("hand", m_hand),
    m_receiveOut("receive_sound", m_receive),
    m_handoverOut("hand_over_sound", m_handover)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
all_controller_test::~all_controller_test()
{
}



RTC::ReturnCode_t all_controller_test::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("triger", m_trigerIn);
  
  // Set OutPort buffer
  addOutPort("arm", m_armOut);
  addOutPort("hand", m_handOut);
  addOutPort("receive_sound", m_receiveOut);
  addOutPort("hand_over_sound", m_handoverOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // </rtc-template>
  
  return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t all_controller_test::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t all_controller_test::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t all_controller_test::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t all_controller_test::onActivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t all_controller_test::onDeactivated(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t all_controller_test::onExecute(RTC::UniqueId ec_id)
{
	if (m_trigerIn.isNew()){
		m_trigerIn.read();
	}

	if (m_triger.data == 1 && i == 0)
	{
		m_arm.data.x = -40;
		m_arm.data.y = -300;
		m_arm.data.z = 80;
		m_armOut.write();
		m_hand.data = 0;
		m_handOut.write();
		m_receive.data = 0;
		m_receiveOut.write();
		m_handover.data = 0;
		m_handoverOut.write();
		i = i + 1;
	}
	m_triger.data = 0;

	switch (i)
	{

	case 1:		//hႤ
		m_arm.data.x = 220;		//h󂯓nꏊ
		m_arm.data.y = 0;
		m_arm.data.z = 220;
		m_armOut.write();
		m_receive.data = 1;
		m_receiveOut.write();
		Sleep(5000);
		m_hand.data = 1;
		m_handOut.write();
		Sleep(5000);
		i = i + 1;
		break;

	case 2:		//huꏊֈړhu
		m_arm.data.x = -40;		
		m_arm.data.y = -300;
		m_arm.data.z = 80;
		m_armOut.write();
		Sleep(3000);
		m_hand.data = 0;
		m_handOut.write();
		Sleep(5000);
		i = i + 1;
		break;

	case 3:		//hEꏊɈړhE
		m_arm.data.x = -40;		
		m_arm.data.y = 300;
		m_arm.data.z = 90;
		m_armOut.write();
		Sleep(4000);
		m_hand.data = 1;
		m_handOut.write();
		Sleep(5000);
		i = i + 1;
		break;

	case 4:
		m_arm.data.x = 220;		//h󂯓nꏊ
		m_arm.data.y = 0;
		m_arm.data.z = 220;
		m_armOut.write();
		Sleep(2000);
		m_handover.data = 1;
		m_handoverOut.write();
		Sleep(2000);
		m_hand.data = 0;
		m_handOut.write();
		Sleep(5000);
		m_arm.data.x = -40;
		m_arm.data.y = -300;
		m_arm.data.z = 80;
		m_armOut.write();
		Sleep(5000);
		i = 0;
		break;

	default:
		break;

	}
	return RTC::RTC_OK;

}

/*
RTC::ReturnCode_t all_controller_test::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t all_controller_test::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t all_controller_test::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t all_controller_test::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t all_controller_test::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{
 
  void all_controller_testInit(RTC::Manager* manager)
  {
    coil::Properties profile(all_controller_test_spec);
    manager->registerFactory(profile,
                             RTC::Create<all_controller_test>,
                             RTC::Delete<all_controller_test>);
  }
  
};


