// -*- C++ -*-
/*!
* @file  kinect2main.cpp
* @brief ModuleDescription
* @date $Date$
*
* $Id$
*/

#include "kinect2main.h"


// Module specification
// <rtc-template block="module_spec">
static const char* kinect2main_spec[] =
{
	"implementation_id", "kinect2main",
	"type_name", "kinect2main",
	"description", "ModuleDescription",
	"version", "1.0.0",
	"vendor", "unos",
	"category", "Category",
	"activity_type", "PERIODIC",
	"kind", "DataFlowComponent",
	"max_instance", "1",
	"language", "C++",
	"lang_type", "compile",
	// Configuration variables
	"conf.default.conf_name0", "1",

	// Widget
	"conf.__widget__.conf_name0", "text",
	// Constraints

	"conf.__type__.conf_name0", "double",

	""
};
// </rtc-template>

/*!
* @brief constructor
* @param manager Maneger Object
*/
kinect2main::kinect2main(RTC::Manager* manager)
// <rtc-template block="initializer">
: RTC::DataFlowComponentBase(manager),
m_Image_inIn("imagein", m_Image_in),
m_Depth_inIn("depthin", m_Depth_in),
m_triggerOut("trigger", m_trigger)
{
	// </rtc-template>
};



/*!
* @brief destructor
*/
kinect2main::~kinect2main()
{
}



RTC::ReturnCode_t kinect2main::onInitialize()
{
	// Registration: InPort/OutPort/Service
	// <rtc-template block="registration">
	// Set InPort buffers
	addInPort("imagein", m_Image_inIn);
	addInPort("depthin", m_Depth_inIn);

	// Set OutPort buffer
	addOutPort("trigger", m_triggerOut);

	// Set service provider to Ports

	// Set service consumers to Ports

	// Set CORBA Service Ports

	// </rtc-template>

	// <rtc-template block="bind_config">
	// Bind variables and configuration variable
	bindParameter("conf_name0", m_conf_name0, "1");
	// </rtc-template>

	return RTC::RTC_OK;
}

/*
RTC::ReturnCode_t kinect2main::onFinalize()
{
return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t kinect2main::onStartup(RTC::UniqueId ec_id)
{
return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t kinect2main::onShutdown(RTC::UniqueId ec_id)
{
return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t kinect2main::onActivated(RTC::UniqueId ec_id)
{
	//m_trigger.data.length(1);
	//m_trigger.data[0] = 0;
	//std::cout << m_trigger.data[0] << std::endl;
	m_trigger.data = 0;
	std::cout << m_trigger.data << std::endl;
	counter = 0;
	counter2 = 0;
	index = 0;
	maxindex = m_Depth_in.width * m_Depth_in.height;
	return RTC::RTC_OK;
}


/*
RTC::ReturnCode_t kinect2main::onDeactivated(RTC::UniqueId ec_id)
{
return RTC::RTC_OK;
}
*/


RTC::ReturnCode_t kinect2main::onExecute(RTC::UniqueId ec_id)
{
	if (m_Depth_inIn.isNew()) {
		m_Depth_inIn.read();
		//std::cout << m_trigger.data[0] << std::endl;
		double distance = 1000;
		int human = 20000;  //320*240 = 76800
		for (int j = 0; j < m_Depth_in.height; j++) {
			for (int i = 0; i < m_Depth_in.width; i++) {
				index = j * m_Depth_in.width + i;
				double bit = m_Depth_in.bits[index];
				counter2++;
				//if (index == 38400){
				if (i == m_Depth_in.width / 2 && j == m_Depth_in.height / 2) {
					std::cout << "Distance: " << m_Depth_in.bits[index] << std::endl;
					if (m_Depth_in.bits[index] <= distance){
						//m_trigger.data[0] = 1;
						m_trigger.data = 1;

						bool(m_triggerOut.write());
						//std::cout << m_trigger.data[0] << std::endl;
						std::cout << m_trigger.data << std::endl;
					}
					else {
						//m_trigger.data[0] = 0;
						m_trigger.data = 0;
						bool(m_triggerOut.write());
						//std::cout << m_trigger.data[0] << std::endl;
						std::cout << m_trigger.data << std::endl;
					}

					/*if (bit <= distance){
						counter++;
						if (counter >= human){
						m_trigger.data[0] = 1;
						bool(m_triggerOut.write());
						std::cout << m_trigger.data[0] << std::endl;
						}
						}
						else {
						m_trigger.data[0] = 0;
						bool(m_triggerOut.write());
						std::cout << m_trigger.data[0] << std::endl;
						}
						}
						if (counter2 == maxindex){
						counter = 0;
						}*/
				}
			}
		}
		return RTC::RTC_OK;
	}
}
/*
RTC::ReturnCode_t kinect2main::onAborting(RTC::UniqueId ec_id)
{
return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t kinect2main::onError(RTC::UniqueId ec_id)
{
return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t kinect2main::onReset(RTC::UniqueId ec_id)
{
return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t kinect2main::onStateUpdate(RTC::UniqueId ec_id)
{
return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t kinect2main::onRateChanged(RTC::UniqueId ec_id)
{
return RTC::RTC_OK;
}
*/



extern "C"
{

	void kinect2mainInit(RTC::Manager* manager)
	{
		coil::Properties profile(kinect2main_spec);
		manager->registerFactory(profile,
			RTC::Create<kinect2main>,
			RTC::Delete<kinect2main>);
	}

};